"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactRedux = require("react-redux");
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _APIController = _interopRequireDefault(require("./APIController.react"));
var _Loading = _interopRequireDefault(require("./components/core/Loading.react"));
var _Toolbar = _interopRequireDefault(require("./components/core/Toolbar.react"));
var _Reloader = _interopRequireDefault(require("./components/core/Reloader.react"));
var _config = _interopRequireDefault(require("./config"));
var _index = require("./actions/index");
var _ramda = require("ramda");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var UnconnectedAppContainer = /*#__PURE__*/function (_React$Component) {
  function UnconnectedAppContainer(props) {
    var _this;
    _classCallCheck(this, UnconnectedAppContainer);
    _this = _callSuper(this, UnconnectedAppContainer, [props]);
    if (props.hooks.layout_pre !== null || props.hooks.layout_post !== null || props.hooks.request_pre !== null || props.hooks.request_post !== null || props.hooks.callback_resolved !== null || props.hooks.request_refresh_jwt !== null) {
      var hooks = props.hooks;
      if (hooks.request_refresh_jwt) {
        hooks = _objectSpread(_objectSpread({}, hooks), {}, {
          request_refresh_jwt: (0, _ramda.memoizeWith)(_ramda.identity, hooks.request_refresh_jwt)
        });
      }
      props.dispatch((0, _index.setHooks)(hooks));
    }
    return _this;
  }
  _inherits(UnconnectedAppContainer, _React$Component);
  return _createClass(UnconnectedAppContainer, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var dispatch = this.props.dispatch;
      var config = (0, _config.default)();

      // preset common request params in the config
      config.fetch = {
        credentials: 'same-origin',
        headers: {
          Accept: 'application/json',
          'Content-Type': 'application/json'
        }
      };
      dispatch((0, _index.setConfig)(config));
    }
  }, {
    key: "render",
    value: function render() {
      var config = this.props.config;
      if ((0, _ramda.type)(config) === 'Null') {
        return /*#__PURE__*/_react.default.createElement("div", {
          className: "_dash-loading"
        }, "Loading...");
      }
      var show_undo_redo = config.show_undo_redo;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, show_undo_redo ? /*#__PURE__*/_react.default.createElement(_Toolbar.default, null) : null, /*#__PURE__*/_react.default.createElement(_APIController.default, null), /*#__PURE__*/_react.default.createElement(_Loading.default, null), /*#__PURE__*/_react.default.createElement(_Reloader.default, null));
    }
  }]);
}(_react.default.Component);
UnconnectedAppContainer.propTypes = {
  hooks: _propTypes.default.object,
  dispatch: _propTypes.default.func,
  config: _propTypes.default.object
};
var AppContainer = (0, _reactRedux.connect)(function (state) {
  return {
    history: state.history,
    config: state.config
  };
}, function (dispatch) {
  return {
    dispatch: dispatch
  };
})(UnconnectedAppContainer);
var _default = exports.default = AppContainer;