"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combineIdAndProp = exports.INDIRECT = exports.DIRECT = void 0;
exports.getAllSubsequentOutputsForCallback = getAllSubsequentOutputsForCallback;
exports.getCallbacksByInput = getCallbacksByInput;
exports.getLayoutCallbacks = void 0;
exports.getPriority = getPriority;
exports.getUniqueIdentifier = exports.getReadyCallbacks = void 0;
exports.includeObservers = includeObservers;
exports.mergeMax = exports.makeResolvedCallback = void 0;
exports.pruneCallbacks = pruneCallbacks;
exports.resolveDeps = resolveDeps;
var _ramda = require("ramda");
var _dependencies = require("./dependencies");
var _paths = require("./paths");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var DIRECT = exports.DIRECT = 2;
var INDIRECT = exports.INDIRECT = 1;
var mergeMax = exports.mergeMax = (0, _ramda.mergeWith)(Math.max);
var combineIdAndProp = exports.combineIdAndProp = function combineIdAndProp(_ref) {
  var id = _ref.id,
    property = _ref.property;
  return "".concat((0, _dependencies.stringifyId)(id), ".").concat(property);
};
function getCallbacksByInput(graphs, paths, id, prop, changeType) {
  var withPriority = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : true;
  var matches = [];
  var idAndProp = combineIdAndProp({
    id: id,
    property: prop
  });
  if (typeof id === 'string') {
    // standard id version
    var callbacks = (graphs.inputMap[id] || {})[prop];
    if (!callbacks) {
      return [];
    }
    callbacks.forEach((0, _dependencies.addAllResolvedFromOutputs)(resolveDeps(), paths, matches));
  } else {
    // wildcard version
    var _keys = Object.keys(id).sort();
    var vals = (0, _ramda.props)(_keys, id);
    var keyStr = _keys.join(',');
    var patterns = (graphs.inputPatterns[keyStr] || {})[prop];
    if (!patterns) {
      return [];
    }
    patterns.forEach(function (pattern) {
      if ((0, _dependencies.idMatch)(_keys, vals, pattern.values)) {
        pattern.callbacks.forEach((0, _dependencies.addAllResolvedFromOutputs)(resolveDeps(_keys, vals, pattern.values), paths, matches));
      }
    });
  }
  matches.forEach(function (match) {
    match.changedPropIds[idAndProp] = changeType || DIRECT;
    if (withPriority) {
      match.priority = getPriority(graphs, paths, match);
    }
  });
  return matches;
}

/*
 * Builds a tree of all callbacks that can be triggered by the provided callback.
 * Uses the number of callbacks at each tree depth and the total depth of the tree
 * to create a sortable priority hash.
 */
function getPriority(graphs, paths, callback) {
  var callbacks = [callback];
  var touchedOutputs = {};
  var touchedCbIds = {};
  var priority = [];
  while (callbacks.length) {
    callbacks = (0, _ramda.filter)(function (c) {
      var touched = touchedCbIds[c.resolvedId];
      touchedCbIds[c.resolvedId] = true;
      return touched;
    }, callbacks);
    var outputs = (0, _ramda.filter)(function (o) {
      return !touchedOutputs[combineIdAndProp(o)];
    }, (0, _ramda.flatten)((0, _ramda.map)(function (cb) {
      return (0, _ramda.flatten)(cb.getOutputs(paths));
    }, callbacks)));
    outputs.forEach(function (o) {
      return touchedOutputs[combineIdAndProp(o)] = true;
    });
    callbacks = (0, _ramda.flatten)((0, _ramda.map)(function (_ref2) {
      var id = _ref2.id,
        property = _ref2.property;
      return getCallbacksByInput(graphs, paths, id, property, INDIRECT, false);
    }, outputs));
    if (callbacks.length) {
      priority.push(callbacks.length);
    }
  }
  priority.unshift(priority.length);
  return (0, _ramda.map)(function (i) {
    return Math.min(i, 35).toString(36);
  }, priority).join('');
}
function getAllSubsequentOutputsForCallback(graphs, paths, callback) {
  var callbacks = [callback];
  var touchedOutputs = {};

  // this traverses the graph all the way to the end
  while (callbacks.length) {
    // don't add it if it already exists based on id and props
    var outputs = (0, _ramda.filter)(function (o) {
      return !touchedOutputs[combineIdAndProp(o)];
    }, (0, _ramda.flatten)((0, _ramda.map)(function (cb) {
      return (0, _ramda.flatten)(cb.getOutputs(paths));
    }, callbacks)));
    touchedOutputs = (0, _ramda.reduce)(function (touched, o) {
      return (0, _ramda.assoc)(combineIdAndProp(o), true, touched);
    }, touchedOutputs, outputs);
    callbacks = (0, _ramda.flatten)((0, _ramda.map)(function (_ref3) {
      var id = _ref3.id,
        property = _ref3.property;
      return getCallbacksByInput(graphs, paths, id, property, INDIRECT, false);
    }, outputs));
  }
  return touchedOutputs;
}
var getReadyCallbacks = exports.getReadyCallbacks = function getReadyCallbacks(paths, candidates) {
  var callbacks = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : candidates;
  var graphs = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  // Skip if there's no candidates
  if (!candidates.length) {
    return [];
  }

  // Find all outputs of all active callbacks
  var outputs = (0, _ramda.map)(combineIdAndProp, (0, _ramda.reduce)(function (o, cb) {
    return (0, _ramda.concat)(o, (0, _ramda.flatten)(cb.getOutputs(paths)));
  }, [], callbacks));

  // Make `outputs` hash table for faster access
  var outputsMap = {};
  outputs.forEach(function (output) {
    return outputsMap[output] = true;
  });

  // find all the outputs touched by activeCallbacks
  // remove this check if graph is accessible all the time

  if (Object.keys(graphs).length) {
    //not sure if graph will be accessible all the time
    var allTouchedOutputs = (0, _ramda.flatten)((0, _ramda.map)(function (cb) {
      return getAllSubsequentOutputsForCallback(graphs, paths, cb);
    }, callbacks));

    // overrrides the outputsMap, will duplicate callbacks filtered
    // this is only done to silence typescript errors
    if (allTouchedOutputs.length > 0) {
      outputsMap = Object.assign.apply(Object, [allTouchedOutputs[0]].concat(_toConsumableArray(allTouchedOutputs)));
    }
  }

  // Ramda.JS `difference` function is slow because it compares objects entirely
  // This cause the following `filter` to be exponentially slow as the number of inputs or outputs grow
  // We can optimize this by comparing only the `id+prop` part of the inputs & outputs.
  // Original difference takes 380ms on average to compute difference between 200 inputs and 1 output.
  // The following function takes 1-2ms on average.
  var differenceBasedOnId = function differenceBasedOnId(inputs, outputs) {
    return inputs.filter(function (input) {
      return !outputs.some(function (output) {
        return combineIdAndProp(input) === combineIdAndProp(output);
      });
    });
  };

  // Find `requested` callbacks that do not depend on a outstanding output (as either input or state)
  // Outputs which overlap an input do not count as an outstanding output
  return (0, _ramda.filter)(function (cb) {
    return (0, _ramda.all)(function (cbp) {
      return !outputsMap[combineIdAndProp(cbp)];
    }, differenceBasedOnId((0, _ramda.flatten)(cb.getInputs(paths)), (0, _ramda.flatten)(cb.getOutputs(paths))));
  }, candidates);
};
var getLayoutCallbacks = exports.getLayoutCallbacks = function getLayoutCallbacks(graphs, paths, layout, options) {
  var exclusions = [];
  var callbacks = (0, _dependencies.getUnfilteredLayoutCallbacks)(graphs, paths, layout, options);

  /*
      Remove from the initial callbacks those that are left with only excluded inputs.
       Exclusion of inputs happens when:
      - an input is missing
      - an input in the initial callback chain depends only on excluded inputs
       Further exclusion might happen after callbacks return with:
      - PreventUpdate
      - no_update
  */
  while (true) {
    // Find callbacks for which all inputs are missing or in the exclusions
    var _partition = (0, _ramda.partition)(function (_ref4) {
        var inputs = _ref4.callback.inputs,
          getInputs = _ref4.getInputs;
        return (0, _ramda.all)(_dependencies.isMultiValued, inputs) || !(0, _ramda.isEmpty)((0, _ramda.difference)((0, _ramda.map)(combineIdAndProp, (0, _ramda.flatten)(getInputs(paths))), exclusions));
      }, callbacks),
      _partition2 = _slicedToArray(_partition, 2),
      included = _partition2[0],
      excluded = _partition2[1];

    // If there's no additional exclusions, break loop - callbacks have been cleaned
    if (!excluded.length) {
      break;
    }
    callbacks = included;

    // update exclusions with all additional excluded outputs
    exclusions = (0, _ramda.concat)(exclusions, (0, _ramda.map)(combineIdAndProp, (0, _ramda.flatten)((0, _ramda.map)(function (_ref5) {
      var getOutputs = _ref5.getOutputs;
      return getOutputs(paths);
    }, excluded))));
  }
  if (options.filterRoot) {
    var rootId = (0, _ramda.path)(['props', 'id'], layout);
    if (rootId) {
      rootId = (0, _dependencies.stringifyId)(rootId);
      // Filter inputs that are not present in the response
      callbacks = callbacks.filter(function (cb) {
        return cb.callback.inputs.reduce(function (previous, input) {
          return previous || (0, _dependencies.stringifyId)(input.id) == rootId && options.filterRoot.includes(input.property);
        }, false);
      });
    }
  }

  /*
      Return all callbacks with an `executionGroup` to allow group-processing
  */
  var executionGroup = Math.random().toString(16);
  return (0, _ramda.map)(function (cb) {
    return _objectSpread(_objectSpread({}, cb), {}, {
      executionGroup: executionGroup
    });
  }, callbacks);
};
var getUniqueIdentifier = exports.getUniqueIdentifier = function getUniqueIdentifier(_ref6) {
  var anyVals = _ref6.anyVals,
    _ref6$callback = _ref6.callback,
    inputs = _ref6$callback.inputs,
    outputs = _ref6$callback.outputs,
    state = _ref6$callback.state;
  return (0, _ramda.concat)((0, _ramda.map)(combineIdAndProp, [].concat(_toConsumableArray(inputs), _toConsumableArray(outputs), _toConsumableArray(state))), Array.isArray(anyVals) ? anyVals : anyVals === '' ? [] : [anyVals]).join(',');
};
function includeObservers(id, properties, graphs, paths) {
  return (0, _ramda.flatten)((0, _ramda.map)(function (propName) {
    return getCallbacksByInput(graphs, paths, id, propName);
  }, (0, _ramda.keys)(properties)));
}

/*
 * Create a pending callback object. Includes the original callback definition,
 * its resolved ID (including the value of all MATCH wildcards),
 * accessors to find all inputs, outputs, and state involved in this
 * callback (lazy as not all users will want all of these).
 */
var makeResolvedCallback = exports.makeResolvedCallback = function makeResolvedCallback(callback, resolve, anyVals) {
  return {
    callback: callback,
    anyVals: anyVals,
    resolvedId: callback.output + anyVals,
    getOutputs: function getOutputs(paths) {
      return callback.outputs.map(resolve(paths));
    },
    getInputs: function getInputs(paths) {
      return callback.inputs.map(resolve(paths));
    },
    getState: function getState(paths) {
      return callback.state.map(resolve(paths));
    },
    changedPropIds: {},
    initialCall: false
  };
};
function pruneCallbacks(callbacks, paths) {
  var _partition3 = (0, _ramda.partition)(function (_ref7) {
      var getOutputs = _ref7.getOutputs,
        outputs = _ref7.callback.outputs;
      return (0, _ramda.flatten)(getOutputs(paths)).length === outputs.length;
    }, callbacks),
    _partition4 = _slicedToArray(_partition3, 2),
    removed = _partition4[1];
  var _partition5 = (0, _ramda.partition)(function (_ref8) {
      var getOutputs = _ref8.getOutputs;
      return !(0, _ramda.flatten)(getOutputs(paths)).length;
    }, removed),
    _partition6 = _slicedToArray(_partition5, 2),
    modified = _partition6[1];
  var added = (0, _ramda.map)(function (cb) {
    return (0, _ramda.assoc)('changedPropIds', (0, _ramda.pickBy)(function (_, propId) {
      return (0, _paths.getPath)(paths, (0, _dependencies.splitIdAndProp)(propId).id);
    }, cb.changedPropIds), cb);
  }, modified);
  return {
    added: added,
    removed: removed
  };
}
function resolveDeps(refKeys, refVals, refPatternVals) {
  return function (paths) {
    return function (_ref9) {
      var idPattern = _ref9.id,
        property = _ref9.property;
      if (typeof idPattern === 'string') {
        var _path = (0, _paths.getPath)(paths, idPattern);
        return _path ? [{
          id: idPattern,
          property: property,
          path: _path
        }] : [];
      }
      var _keys = Object.keys(idPattern).sort();
      var patternVals = (0, _ramda.props)(_keys, idPattern);
      var keyStr = _keys.join(',');
      var keyPaths = paths.objs[keyStr];
      if (!keyPaths) {
        return [];
      }
      var result = [];
      keyPaths.forEach(function (_ref10) {
        var vals = _ref10.values,
          path = _ref10.path;
        if ((0, _dependencies.idMatch)(_keys, vals, patternVals, refKeys, refVals, refPatternVals)) {
          result.push({
            id: (0, _ramda.zipObj)(_keys, vals),
            property: property,
            path: path
          });
        }
      });
      return result;
    };
  };
}