"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DebugMenu = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ramda = require("ramda");
require("./DebugMenu.css");
var _CheckIcon = _interopRequireDefault(require("../icons/CheckIcon.svg"));
var _ClockIcon = _interopRequireDefault(require("../icons/ClockIcon.svg"));
var _ErrorIcon = _interopRequireDefault(require("../icons/ErrorIcon.svg"));
var _GraphIcon = _interopRequireDefault(require("../icons/GraphIcon.svg"));
var _OffIcon = _interopRequireDefault(require("../icons/OffIcon.svg"));
var _Expand = _interopRequireDefault(require("../icons/Expand.svg"));
var _VersionInfo = require("./VersionInfo.react");
var _CallbackGraphContainer = require("../CallbackGraph/CallbackGraphContainer.react");
var _FrontEndErrorContainer = require("../FrontEnd/FrontEndErrorContainer.react");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var classes = function classes(base, variant, variant2) {
  return "".concat(base, " ").concat(base, "--").concat(variant) + (variant2 ? " ".concat(base, "--").concat(variant2) : '');
};
var isCollapsed = function isCollapsed() {
  try {
    return localStorage.getItem('dash_debug_menu_collapsed') === 'true';
  } catch (e) {
    // If localStorage is not available, default to false
    return false;
  }
};
var MenuContent = function MenuContent(_ref) {
  var hotReload = _ref.hotReload,
    connected = _ref.connected,
    popup = _ref.popup,
    toggleErrors = _ref.toggleErrors,
    errCount = _ref.errCount,
    toggleCallbackGraph = _ref.toggleCallbackGraph,
    config = _ref.config;
  var _StatusIcon = hotReload ? connected ? _CheckIcon.default : _OffIcon.default : _ClockIcon.default;
  var status = hotReload ? connected ? 'available' : 'unavailable' : 'cold';
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__content"
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: toggleErrors,
    className: (popup == 'errors' ? 'dash-debug-menu__button--selected' : null) + ' dash-debug-menu__button',
    id: "dash-debug-menu__errors-button"
  }, /*#__PURE__*/_react.default.createElement(_ErrorIcon.default, {
    className: "dash-debug-menu__icon"
  }), "Errors", errCount > 0 ? /*#__PURE__*/_react.default.createElement("span", {
    className: "test-devtools-error-count dash-debug-menu__error-count"
  }, errCount) : null), /*#__PURE__*/_react.default.createElement("button", {
    onClick: toggleCallbackGraph,
    className: (popup == 'callbackGraph' ? 'dash-debug-menu__button--selected' : '') + ' dash-debug-menu__button',
    id: "dash-debug-menu__callback-graph-button"
  }, /*#__PURE__*/_react.default.createElement(_GraphIcon.default, {
    className: "dash-debug-menu__icon"
  }), "Callbacks"), /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__divider"
  }), /*#__PURE__*/_react.default.createElement(_VersionInfo.VersionInfo, {
    config: config
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__divider"
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__status dash-debug-menu__button--".concat(status)
  }, "Server", /*#__PURE__*/_react.default.createElement(_StatusIcon, {
    className: "dash-debug-menu__icon"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__divider",
    style: {
      marginRight: 0
    }
  }));
};
var DebugMenu = exports.DebugMenu = function DebugMenu(_ref2) {
  var error = _ref2.error,
    hotReload = _ref2.hotReload,
    config = _ref2.config,
    children = _ref2.children;
  var _useState = (0, _react.useState)('errors'),
    _useState2 = _slicedToArray(_useState, 2),
    popup = _useState2[0],
    setPopup = _useState2[1];
  var _useState3 = (0, _react.useState)(isCollapsed),
    _useState4 = _slicedToArray(_useState3, 2),
    collapsed = _useState4[0],
    setCollapsed = _useState4[1];
  var errCount = error.frontEnd.length + error.backEnd.length;
  var connected = error.backEndConnected;
  (0, _react.useEffect)(function () {
    if (errCount > 0 && popup == null) {
      setPopup('errors');
    }
  }, [errCount]);
  var toggleErrors = function toggleErrors() {
    setPopup(popup == 'errors' ? null : 'errors');
  };
  var toggleCallbackGraph = function toggleCallbackGraph() {
    setPopup(popup == 'callbackGraph' ? null : 'callbackGraph');
  };
  var toggleCollapsed = function toggleCollapsed() {
    setCollapsed(!collapsed);
    try {
      localStorage.setItem('dash_debug_menu_collapsed', !collapsed);
    } catch (e) {
      // If localStorage is not available, do nothing
    }
  };
  var errors = (0, _ramda.concat)(error.frontEnd, error.backEnd);
  var popupContent = /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__popup"
  }, popup == 'callbackGraph' ? /*#__PURE__*/_react.default.createElement(_CallbackGraphContainer.CallbackGraphContainer, null) : undefined, popup == 'errors' && errCount > 0 ? /*#__PURE__*/_react.default.createElement(_FrontEndErrorContainer.FrontEndErrorContainer, {
    clickHandler: toggleErrors,
    errors: errors,
    connected: error.backEndConnected
  }) : undefined);
  var menuContent = collapsed ? undefined : /*#__PURE__*/_react.default.createElement(MenuContent, {
    popup: popup,
    errCount: errCount,
    toggleErrors: toggleErrors,
    toggleCallbackGraph: toggleCallbackGraph,
    config: config,
    hotReload: hotReload,
    connected: connected
  });
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
    className: classes('dash-debug-menu__outer', collapsed ? 'collapsed' : 'expanded')
  }, popupContent, menuContent, /*#__PURE__*/_react.default.createElement("button", {
    onClick: toggleCollapsed,
    className: classes('dash-debug-menu__toggle', collapsed ? 'collapsed' : 'expanded')
  }, /*#__PURE__*/_react.default.createElement(_Expand.default, null), errCount > 0 && collapsed ? /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__error-indicator"
  }) : null)), children);
};
DebugMenu.propTypes = {
  children: _propTypes.default.object,
  error: _propTypes.default.object,
  hotReload: _propTypes.default.bool,
  config: _propTypes.default.object
};