"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = error;
var _ramda = require("ramda");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var initialError = {
  frontEnd: [],
  backEnd: [],
  backEndConnected: true
};
function error() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialError;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case 'ON_ERROR':
      {
        var frontEnd = state.frontEnd,
          backEnd = state.backEnd,
          backEndConnected = state.backEndConnected;
        // log errors to the console for stack tracing and so they're
        // available even with debugging off
        /* eslint-disable-next-line no-console */
        console.error(action.payload.error);
        if (action.payload.type === 'frontEnd') {
          return {
            frontEnd: [(0, _ramda.mergeRight)(action.payload, {
              timestamp: new Date()
            })].concat(_toConsumableArray(frontEnd)),
            backEnd: backEnd,
            backEndConnected: backEndConnected
          };
        } else if (action.payload.type === 'backEnd') {
          return {
            frontEnd: frontEnd,
            backEnd: [(0, _ramda.mergeRight)(action.payload, {
              timestamp: new Date()
            })].concat(_toConsumableArray(backEnd)),
            backEndConnected: backEndConnected
          };
        }
        return state;
      }
    case 'SET_CONNECTION_STATUS':
      {
        return (0, _ramda.mergeRight)(state, {
          backEndConnected: action.payload
        });
      }
    default:
      {
        return state;
      }
  }
}