"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _ramda = require("ramda");
var _redux = require("redux");
var _reduxThunk = _interopRequireDefault(require("redux-thunk"));
var _reducer = require("./reducers/reducer");
var _StoreObserver = _interopRequireDefault(require("./StoreObserver"));
var _documentTitle = _interopRequireDefault(require("./observers/documentTitle"));
var _executedCallbacks = _interopRequireDefault(require("./observers/executedCallbacks"));
var _executingCallbacks = _interopRequireDefault(require("./observers/executingCallbacks"));
var _isLoading = _interopRequireDefault(require("./observers/isLoading"));
var _prioritizedCallbacks = _interopRequireDefault(require("./observers/prioritizedCallbacks"));
var _requestedCallbacks = _interopRequireDefault(require("./observers/requestedCallbacks"));
var _storedCallbacks = _interopRequireDefault(require("./observers/storedCallbacks"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// FIXME add proper type for the store.
// Deprecated
var RendererStore = exports.default = /*#__PURE__*/function () {
  function RendererStore() {
    var _this = this;
    _classCallCheck(this, RendererStore);
    _defineProperty(this, "__store", void 0);
    _defineProperty(this, "storeObserver", new _StoreObserver.default());
    _defineProperty(this, "setObservers", (0, _ramda.once)(function () {
      var observe = _this.storeObserver.observe;

      // FIXME Remove observer pattern and refactor to standard reducers/actions/selectors.
      observe(_documentTitle.default);
      observe(_isLoading.default);
      observe(_requestedCallbacks.default);
      observe(_prioritizedCallbacks.default);
      observe(_executingCallbacks.default);
      observe(_executedCallbacks.default);
      observe(_storedCallbacks.default);
    }));
    _defineProperty(this, "createAppStore", function (reducer, middleware) {
      _this.__store = (0, _redux.createStore)(reducer, middleware);
      _this.storeObserver.setStore(_this.__store);
      var ds = window.dash_stores = window.dash_stores || [];
      if (!ds.includes(_this.__store)) {
        ds.push(_this.__store);
      }
      _this.setObservers();
    });
    /**
     * Initialize a Redux store with thunk, plus logging (only in development mode) middleware
     *
     * @param {bool} reset: discard any previous store
     *
     * @returns {Store<GenericStoreEnhancer>}
     *  An initialized redux store with middleware and possible hot reloading of reducers
     */
    _defineProperty(this, "initializeStore", function (reset) {
      if (_this.__store && !reset) {
        return _this.__store;
      }
      var reducer = (0, _reducer.createReducer)();

      // eslint-disable-next-line no-process-env
      if (process.env.NODE_ENV === 'production') {
        _this.createAppStore(reducer, (0, _redux.applyMiddleware)(_reduxThunk.default));
      } else {
        // only attach logger to middleware in non-production mode
        var reduxDTEC = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__;
        if (reduxDTEC) {
          _this.createAppStore(reducer, reduxDTEC({
            actionsDenylist: ['reloadRequest']
          })((0, _redux.applyMiddleware)(_reduxThunk.default)));
        } else {
          _this.createAppStore(reducer, (0, _redux.applyMiddleware)(_reduxThunk.default));
        }
      }
      if (!reset) {
        // TODO - Protect this under a debug mode?
        window.store = _this.__store;
      }
      if (module.hot) {
        // Enable hot module replacement for reducers
        module.hot.accept('./reducers/reducer', function () {
          var nextRootReducer = require('./reducers/reducer').createReducer();
          _this.__store.replaceReducer(nextRootReducer);
        });
      }
      return _this.__store;
    });
    this.__store = this.initializeStore();
  }
  return _createClass(RendererStore, [{
    key: "store",
    get: function get() {
      return this.__store;
    }
  }]);
}();