"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadLibrary = loadLibrary;
function loadLibrary(resource) {
  var prom;
  var head = document.querySelector('head');
  if (resource.type === '_js_dist') {
    var element = document.createElement('script');
    element.src = resource.url;
    element.async = true;
    prom = new Promise(function (resolve, reject) {
      element.onload = function () {
        resolve();
      };
      element.onerror = function (error) {
        return reject(error);
      };
    });
    head === null || head === void 0 || head.appendChild(element);
  } else if (resource.type === '_css_dist') {
    var _element = document.createElement('link');
    _element.href = resource.url;
    _element.rel = 'stylesheet';
    prom = new Promise(function (resolve, reject) {
      _element.onload = function () {
        resolve();
      };
      _element.onerror = function (error) {
        return reject(error);
      };
    });
    head === null || head === void 0 || head.appendChild(_element);
  }
  return prom;
}