"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CheckedComponent;
var _checkPropTypes = _interopRequireDefault(require("../checkPropTypes"));
var _exceptions = require("../exceptions");
var _wrapping = require("./wrapping");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function CheckedComponent(p) {
  var element = p.element,
    props = p.props,
    children = p.children,
    component = p.component;
  (0, _wrapping.validateComponent)(component);
  var errorMessage = (0, _checkPropTypes.default)(element.propTypes, props, 'component prop', element);
  if (errorMessage) {
    (0, _exceptions.propTypeErrorHandler)(errorMessage, props, component.type);
  }
  return children;
}