"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DashContext = void 0;
exports.DashContextProvider = DashContextProvider;
exports.useDashContext = useDashContext;
var _react = _interopRequireWildcard(require("react"));
var _reactRedux = require("react-redux");
var _ramda = require("ramda");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var DashContext = exports.DashContext = /*#__PURE__*/_react.default.createContext({});
function DashContextProvider(props) {
  var children = props.children,
    componentPath = props.componentPath;
  var stringPath = (0, _react.useMemo)(function () {
    return JSON.stringify(componentPath);
  }, [componentPath]);
  var store = (0, _reactRedux.useStore)();
  var isLoading = (0, _react.useCallback)(function (options) {
    var _ref = options || {},
      extraPath = _ref.extraPath,
      rawPath = _ref.rawPath,
      filterFunc = _ref.filterFunc;
    var loadingPath = [stringPath];
    if (extraPath) {
      loadingPath = [JSON.stringify((0, _ramda.concat)(componentPath, extraPath))];
    } else if (rawPath) {
      loadingPath = [JSON.stringify(rawPath)];
    }
    var loading = (0, _ramda.pathOr)([], loadingPath, store.getState().loading);
    return filterFunc ? loading.filter(filterFunc).length > 0 : loading.length > 0;
  }, [stringPath]);
  var useLoading = (0, _react.useCallback)(function (options) {
    var _ref2 = options || {},
      filterFunc = _ref2.filterFunc,
      extraPath = _ref2.extraPath,
      rawPath = _ref2.rawPath;
    return (0, _reactRedux.useSelector)(function (state) {
      var loadingPath = [stringPath];
      if (extraPath) {
        loadingPath = [JSON.stringify((0, _ramda.concat)(componentPath, extraPath))];
      } else if (rawPath) {
        loadingPath = [JSON.stringify(rawPath)];
      }
      var load = (0, _ramda.pathOr)([], loadingPath, state.loading);
      if (filterFunc) {
        return load.filter(filterFunc).length > 0;
      }
      return load.length > 0;
    });
  }, [stringPath]);
  var ctxValue = (0, _react.useMemo)(function () {
    return {
      componentPath: componentPath,
      isLoading: isLoading,
      useLoading: useLoading,
      useSelector: _reactRedux.useSelector,
      useStore: _reactRedux.useStore,
      useDispatch: _reactRedux.useDispatch
    };
  }, [stringPath]);
  return /*#__PURE__*/_react.default.createElement(DashContext.Provider, {
    value: ctxValue
  }, children);
}
function useDashContext() {
  var ctx = (0, _react.useContext)(DashContext);
  if (!ctx) {
    // eslint-disable-next-line no-console
    console.error('Dash Context was not found, component was rendered without a wrapper. Use `window.dash_component_api.ExternalWrapper` to make sure the component is properly connected.');
  }
  return ctx || {};
}